org     $8000       ; Direcci?n donde se carga el programa

; Variable de sistema donde est?n los atributos de la pantalla 1.
; La pantalla 1 es la principal.
; El formato es Flash, Bright, Paper, Ink (FBPPPIII).
ATTR_S: equ $5c8d

; Variable de sistema donde est? el atributo actual (FBPPPIII).
ATTR_T: equ $5c8f

; ------------------------------------------------------------
; Rutina de la ROM similar al AT de Basic
; Posiciona el cursor en las coordenadas especificadas.
; Entrada:  B = Coordenada Y.
;           C = Coordenada X.
; Para esta rutina, la esquina superior izquierda de la pantalla
; es (24, 33).
; Altera el valor de los registros A, DE y HL.
; ------------------------------------------------------------
LOCATE:	equ	$0dd9

; ------------------------------------------------------------
; Rutina de la ROM semejante al CLS de Basic.
; Borra la pantalla usando los atributos cargados en la
; variable de sistema ATTR_S.
; Altera el valor de los registros AF, BC, DE y HL.
; ------------------------------------------------------------
CLS:    equ $0daf

Inicio:
ld      a, $0e      ; Carga en A los atributos de color
ld      hl, ATTR_T  ; Carga en HL la direcci?n de memoria donde se
                    ; encuentran los atributos
ld      (hl), a     ; Carga en memoria los atributos de la pantalla
                    ; principal
ld      hl, ATTR_S  ; Carga en HL la direcci?n de memoria donde
                    ; se encuentran los atributos actuales
ld      (hl), a     ; Carga en memoria los atributos actuales

ld      a, $01      ; Carga el color del borde en A
out     ($fe), a    ; Cambia el color del borde

call    CLS         ; Limpia la pantalla usando los atributos de ATTR_T

ld      b, $18-$0a  ; Carga la coordenada Y en B
ld      c, $21-$02  ; Carga la coordenada X en C
call    LOCATE      ; Posiciona el cursor

ld      hl, msg     ; Carga en HL la direcci?n de memoria del mensaje

Bucle:
ld      a, (hl)     ; Carga un car?cter de la cadena
or      a           ; Comprueba si A es 0.
jr      z, Fin      ; Salta a la etiqueta fin si A = 0
rst     $10         ; Imprime el car?cter
inc     hl          ; Apunta HL al siguiente car?cter
jr      Bucle       ; Bucle hasta que A = 0

Fin:
jr      Fin         ; Bucle infinito

msg:    defm        'Hola ensamblador ZX Spectrum', $00
                    ; Cadena terminada en 0 = null

end     $8000